## kwin-x11 6.4.5+p24.04+vstable+git20251004.0544

=== debian/changelog ===
kwin-x11 (4:6.4.5+p24.04+vstable+git20251004.0544-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 04 Oct 2025 05:44:50 +0000

kwin-x11 (4:6.4.5-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 11 Sep 2025 04:49:35 +0000

## kwin-x11 6.4.5+p24.04+vstable+git20251004.0601

=== debian/changelog ===
kwin-x11 (4:6.4.5+p24.04+vstable+git20251004.0601-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 04 Oct 2025 06:01:36 +0000

## kwin-x11 6.4.5+p24.04+vstable+git20251016.0235

=== debian/changelog ===
kwin-x11 (4:6.4.5+p24.04+vstable+git20251016.0235-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 16 Oct 2025 02:35:26 +0000

## kwin-x11 6.4.5+p24.04+vstable+git20251019.0632

=== debian/changelog ===
kwin-x11 (4:6.4.5+p24.04+vstable+git20251019.0632-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 06:32:53 +0000

## kwin-x11 6.4.5+p24.04+vunstable+git20251020.1236

=== debian/changelog ===
kwin-x11 (4:6.4.5+p24.04+vunstable+git20251020.1236-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 12:37:04 +0000

## kwin-x11 6.4.91

=== doc/desktop-x11/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kcontrol/desktop-x11)

=== doc/kwinvirtualkeyboard-x11/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kcontrol/kwinvirtualkeyboard-x11)

=== src/plugins/invert/CMakeLists.txt ===
#######################################
# Effect

set(invert_SOURCES
    invert.cpp
    invert.qrc
    main.cpp
)

kwin_add_builtin_effect(invert ${invert_SOURCES})
target_link_libraries(invert PRIVATE
    kwin

    KF6::GlobalAccel
    KF6::I18n
)

=== src/tabbox/switchers/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Nate Graham <nate@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

set(TABBOX_DIR ${KDE_INSTALL_DATADIR}/${KWIN_DATADIR}/tabbox)
install(DIRECTORY thumbnail_grid   DESTINATION ${TABBOX_DIR})

=== src/kcms/decoration/declarative-plugin/CMakeLists.txt ===
ecm_add_qml_module(kdecorationprivatedeclarative URI org.kde.kwin_x11.private.kdecoration DEPENDENCIES QtCore QtQuick GENERATE_PLUGIN_SOURCE)

target_sources(kdecorationprivatedeclarative PRIVATE
    previewbutton.cpp
    previewbridge.cpp
    previewclient.cpp
    previewitem.cpp
    previewsettings.cpp
    buttonsmodel.cpp
    ../../../decorations/decorationpalette.cpp
    ../../../decorations/decorations_logging.cpp
    types.h
)

target_link_libraries(kdecorationprivatedeclarative PRIVATE
    KDecoration3::KDecoration
    KDecoration3::KDecoration3Private
    Qt::DBus
    Qt::Quick
    KF6::CoreAddons
    KF6::KCMUtils
    KF6::I18n
    KF6::Service
)

ecm_finalize_qml_module(kdecorationprivatedeclarative)

=== debian/changelog ===
kwin-x11 (4:6.4.91-1) experimental; urgency=medium

  [ Rik Mills ]
  * Initial release to Ubuntu (LP: #2110572)

  [ Aurélien COUDERC ]
  * New upstream release (6.4.91).
  * Update build-deps and deps with the info from cmake.
  * Initial release. (Closes: #1117539)
  * Debianize package, thanks Rik Mills for the initial packaging work !
  * Cleanup build-dependencies.
  * Drop /usr/bin/kwin compatibility link.
  * Don’t depend on xorg metapackage.
  * Refresh lintian overrides.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 06 Oct 2025 22:22:41 +0200

=== debian/control ===
Source: kwin-x11
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               breeze-dev (>= 4:6.4.91~),
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.18.0~),
               gettext,
               knighttime-dev (>= 6.4.91~),
               kscreenlocker-dev (>= 6.4.91~),
               kwayland-dev (>= 4:6.4.91~),
               libcanberra-dev,
               libcap-dev [linux-any],
               libcap2-bin [linux-any],
               libdisplay-info-dev,
               libdrm-dev (>= 2.4.116~),
               libegl-dev (>= 1.2~),
               libeis-dev,
               libepoxy-dev (>= 1.3),
               libfontconfig-dev,
               libfreetype-dev,
               libgbm-dev,
               libkdecorations3-dev (>= 4:6.4.91~),
               libkf6auth-dev (>= 6.18.0~),
               libkf6colorscheme-dev (>= 6.18.0~),
               libkf6config-dev (>= 6.18.0~),
               libkf6configwidgets-dev (>= 6.18.0~),
               libkf6coreaddons-dev (>= 6.18.0~),
               libkf6crash-dev (>= 6.18.0~),
               libkf6dbusaddons-dev (>= 6.18.0~),
               libkf6declarative-dev (>= 6.18.0~),
               libkf6doctools-dev (>= 6.18.0~),
               libkf6globalaccel-dev (>= 6.18.0~),
               libkf6guiaddons-dev (>= 6.18.0~),
               libkf6i18n-dev (>= 6.18.0~),
               libkf6idletime-dev (>= 6.18.0~),
               libkf6kcmutils-dev (>= 6.18.0~),
               libkf6newstuff-dev (>= 6.18.0~),
               libkf6notifications-dev (>= 6.18.0~),
               libkf6package-dev (>= 6.18.0~),
               libkf6runner-dev,
               libkf6service-dev (>= 6.18.0~),
               libkf6svg-dev (>= 6.18.0~),
               libkf6widgetsaddons-dev (>= 6.18.0~),
               libkf6windowsystem-dev (>= 6.18.0~),
               libkf6xmlgui-dev (>= 6.18.0~),
               libkglobalacceld-dev (>= 6.4.91~),
               libkirigami-dev (>= 6.18.0~),
               liblcms2-dev,
               libplasma-dev (>= 6.4.91~),
               libplasmaactivities-dev (>= 6.4.91~),
               libqaccessibilityclient-qt6-dev,
               libsystemd-dev [linux-any],
               libudev-dev [linux-any],
               libwayland-dev (>= 1.22~),
               libx11-dev,
               libx11-xcb-dev,
               libxcb-composite0-dev (>= 1.10~),
               libxcb-cursor-dev,
               libxcb-damage0-dev (>= 1.10~),
               libxcb-dri3-dev (>= 1.10~),
               libxcb-glx0-dev (>= 1.10~),
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-present-dev (>= 1.10~),
               libxcb-randr0-dev (>= 1.10~),
               libxcb-render0-dev (>= 1.10~),
               libxcb-res0-dev,
               libxcb-shape0-dev (>= 1.10~),
               libxcb-shm0-dev (>= 1.10~),
               libxcb-sync-dev (>= 1.10~),
               libxcb-util-dev,
               libxcb-xfixes0-dev (>= 1.10~),
               libxcb-xinerama0-dev (>= 1.10~),
               libxcb-xinput-dev (>= 1.10~),
               libxcb-xkb-dev (>= 1.10~),
               libxcb-xtest0-dev,
               libxcb1-dev (>= 1.10~),
               libxcursor-dev,
               libxkbcommon-dev (>= 0.7.0~),
               libxkbcommon-x11-dev,
               pkgconf,
               plasma-wayland-protocols (>= 1.14.0~),
               python3:any,
               qt6-5compat-dev (>= 6.9.0~),
               qt6-base-dev (>= 6.9.0~),
               qt6-base-private-dev (>= 6.8.0+dfsg~),
               qt6-declarative-dev (>= 6.9.0~),
               qt6-declarative-private-dev (>= 6.8.0~),
               qt6-sensors-dev (>= 6.9.0~),
               qt6-svg-dev (>= 6.9.0~),
               qt6-tools-dev (>= 6.9.0~),
               qt6-wayland-dev (>= 6.9.0~),
               qt6-wayland-dev-tools (>= 6.8.0~),
               wayland-protocols (>= 1.38~),
               xwayland (>= 2:23.1.0~),
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/plasma/kwin-x11
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kwin-x11
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kwin-x11.git

Package: kwin-x11
Architecture: any
Depends: hwdata,
         kwin-common,
         kwin-x11-data (= ${source:Version}),
         xauth,
         xinit,
         xkb-data,
         xserver-xorg,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: kwin-style-aurorae,
            kde-style-breeze,
Provides: kwin,
          x-window-manager,
Breaks: kwin-common (<< 4:6.4.0~),
Replaces: kwin-common (<< 4:6.4.0~),
Description: KDE window manager, X11 version
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package provides KWin version for X11.

Package: kwin-x11-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Recommends: plasma-desktoptheme,
            qml6-module-org-kde-kirigami,
            qml6-module-org-kde-kitemmodels,
            qml6-module-org-kde-kquickcontrolsaddons,
            qml6-module-org-kde-ksvg,
            qml6-module-org-kde-quickcharts,
            qml6-module-qt5compat-graphicaleffects,
            qml6-module-qtmultimedia,
            qml6-module-qtqml-workerscript,
            qml6-module-qtquick,
            qml6-module-qtquick-controls,
            qml6-module-qtquick-layouts,
            qml6-module-qtquick-window,
            systemsettings,
Description: KDE window manager X11 data files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package contains the KWin X11 data files

Package: kwin-x11-dev
Section: libdevel
Architecture: any
Depends: libepoxy-dev (>= 1.3),
         libkf6config-dev (>= 6.18.0~),
         libkf6coreaddons-dev (>= 6.18.0~),
         libkf6windowsystem-dev (>= 6.18.0~),
         libkwin-x11-6 (= ${binary:Version}),
         qt6-base-dev (>= 6.9.0~),
         qt6-declarative-dev (>= 6.9.0~),
         ${misc:Depends},
Description: KDE window manager X11 - devel files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package provides the development files for KWin X11

Package: libkwin-x11-6
Section: libs
Architecture: any
Depends: kwin-x11-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE window manager X11 library
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package provides the shared library for KWin X11

## kwin-x11 6.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(PROJECT_VERSION "6.5.0") # Handled by release scripts
project(KWin VERSION ${PROJECT_VERSION})

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(PROJECT_DEP_VERSION "6.5.0")
set(QT_MIN_VERSION "6.9.0")
set(KF6_MIN_VERSION "6.18.0")
set(KDE_COMPILERSETTINGS_LEVEL "5.82")

find_package(ECM ${KF6_MIN_VERSION} REQUIRED NO_MODULE)

set(KWIN_DATADIR kwin-x11)
set(KWIN_PLUGINDIR kwin-x11)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(GenerateExportHeader)
include(CheckCXXSourceCompiles)
include(CheckCXXCompilerFlag)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat)
include(KDEGitCommitHooks)

include(ECMFindQmlModule)
include(ECMInstallIcons)
include(ECMOptionalAddSubdirectory)
include(ECMConfiguredInstall)
include(ECMQtDeclareLoggingCategory)
include(ECMSetupQtPluginMacroNames)
include(ECMSetupVersion)
include(ECMQmlModule)
include(ECMGenerateQmlTypes)
include(ECMDeprecationSettings)

option(KWIN_BUILD_DECORATIONS "Enable building of KWin decorations." ON)
option(KWIN_BUILD_KCMS "Enable building of KWin configuration modules." ON)
option(KWIN_BUILD_NOTIFICATIONS "Enable building of KWin with knotifications support" ON)
option(KWIN_BUILD_SCREENLOCKER "Enable building of KWin lockscreen functionality" ON)
option(KWIN_BUILD_TABBOX "Enable building of KWin Tabbox functionality" ON)
option(KWIN_BUILD_X11 "Enable building X11 common code and Xwayland support" ON)
option(KWIN_BUILD_X11_BACKEND "Enable building kwin_x11" ON)
option(KWIN_BUILD_GLOBALSHORTCUTS "Enable building of KWin with global shortcuts support" ON)
option(KWIN_BUILD_RUNNERS "Enable building of KWin with krunner support" ON)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Concurrent
    Core
    Core5Compat
    DBus
    Quick
    UiTools
    WaylandClient
    Widgets
    Sensors
    Svg
)

if (Qt6Gui_VERSION VERSION_GREATER_EQUAL "6.10.0")
    find_package(Qt6GuiPrivate ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE)
endif()

find_package(Qt6Test ${QT_MIN_VERSION} CONFIG QUIET)
set_package_properties(Qt6Test PROPERTIES
    PURPOSE "Required for tests"
    TYPE OPTIONAL
)
add_feature_info("Qt6Test" Qt6Test_FOUND "Required for building tests")
if (NOT Qt6Test_FOUND)
    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
endif()

# required frameworks by Core
find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS
    Auth
    ColorScheme
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    GlobalAccel
    GuiAddons
    I18n
    IdleTime
    Package
    Service
    Svg
    WidgetsAddons
    WindowSystem
)
# required frameworks by config modules
if(KWIN_BUILD_KCMS)
    find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS
        Declarative
        KCMUtils
        NewStuff
        Service
        XmlGui
    )
endif()

if(KWIN_BUILD_TABBOX AND KWIN_BUILD_KCMS)
    find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS
        WidgetsAddons
    )
endif()

find_package(KNightTime ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(KNightTime PROPERTIES
    PURPOSE "Needed for Night Light"
    TYPE REQUIRED
)

find_package(Threads)
set_package_properties(Threads PROPERTIES
    PURPOSE "Needed for VirtualTerminal support in KWin Wayland"
    TYPE REQUIRED
)

# optional frameworks
find_package(PlasmaActivities ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(PlasmaActivities PROPERTIES
    PURPOSE "Enable building of KWin with kactivities support"
    TYPE OPTIONAL
)
add_feature_info("PlasmaActivities" PlasmaActivities_FOUND "Enable building of KWin with kactivities support")

find_package(KF6DocTools ${KF6_MIN_VERSION} CONFIG)
set_package_properties(KF6DocTools PROPERTIES
    PURPOSE "Enable building documentation"
    TYPE OPTIONAL
)
add_feature_info("KF6DocTools" KF6DocTools_FOUND "Enable building documentation")

find_package(KF6Kirigami ${KF6_MIN_VERSION} CONFIG)
set_package_properties(KF6Kirigami PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime for several QML effects"
    TYPE RUNTIME
)
find_package(Plasma ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(Plasma PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime for several QML effects"
    TYPE RUNTIME
)

find_package(KDecoration3 ${PROJECT_DEP_VERSION} CONFIG REQUIRED)

find_package(Breeze ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(Breeze PROPERTIES
    TYPE OPTIONAL
    PURPOSE "For setting the default window decoration plugin"
)
if (Breeze_FOUND)
    if (BREEZE_WITH_KDECORATION)
        set(HAVE_BREEZE_DECO true)
    else()
        set(HAVE_BREEZE_DECO FALSE)
    endif()
else()
    set(HAVE_BREEZE_DECO FALSE)
endif()
add_feature_info("Breeze-Decoration" HAVE_BREEZE_DECO "Default decoration plugin Breeze")

find_package(Aurorae ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(Aurorae PROPERTIES
    TYPE RUNTIME
    PURPOSE "Provides support for decorations downloaded from the internet"
)

find_package(EGL)
set_package_properties(EGL PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required to build KWin with EGL support"
)

find_package(epoxy 1.3)
set_package_properties(epoxy PROPERTIES
    DESCRIPTION "libepoxy"
    URL "https://github.com/anholt/libepoxy"
    TYPE REQUIRED
    PURPOSE "OpenGL dispatch library"
)

set(HAVE_DL_LIBRARY FALSE)
if (epoxy_HAS_GLX)
    find_library(DL_LIBRARY dl)
    if (DL_LIBRARY)
        set(HAVE_DL_LIBRARY TRUE)
    endif()
endif()

find_package(Wayland 1.22)
set_package_properties(Wayland PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building KWin with Wayland support"
)
if (Wayland_VERSION VERSION_GREATER_EQUAL 1.23)
    set(HAVE_WL_DISPLAY_SET_DEFAULT_MAX_BUFFER_SIZE 1)
else()
    set(HAVE_WL_DISPLAY_SET_DEFAULT_MAX_BUFFER_SIZE 0)
endif()
if (Wayland_VERSION VERSION_GREATER_EQUAL 1.23.90)
    set(HAVE_WL_FIXES 1)
else()
    set(HAVE_WL_FIXES 0)
endif()

find_package(WaylandProtocols 1.38)
set_package_properties(WaylandProtocols PROPERTIES
    TYPE REQUIRED
    PURPOSE "Collection of Wayland protocols that add functionality not available in the Wayland core protocol"
    URL "https://gitlab.freedesktop.org/wayland/wayland-protocols/"
)

find_package(PlasmaWaylandProtocols 1.14.0 CONFIG)
set_package_properties(PlasmaWaylandProtocols PROPERTIES
    TYPE REQUIRED
    PURPOSE "Collection of Plasma-specific Wayland protocols"
    URL "https://invent.kde.org/libraries/plasma-wayland-protocols/"
)

find_package(XKB 0.7.0)
set_package_properties(XKB PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building KWin with Wayland support"
)
if (XKB_VERSION VERSION_GREATER_EQUAL 1.5.0)
    set(HAVE_XKBCOMMON_NO_SECURE_GETENV 1)
else()
    set(HAVE_XKBCOMMON_NO_SECURE_GETENV 0)
endif()

find_package(Canberra REQUIRED)

if (KWIN_BUILD_X11)
    pkg_check_modules(XKBX11 IMPORTED_TARGET xkbcommon-x11 REQUIRED)
    add_feature_info(XKBX11 XKBX11_FOUND "Required for handling keyboard events in X11 backend")

    # All the required XCB components
    find_package(XCB 1.10 REQUIRED COMPONENTS
        COMPOSITE
        CURSOR
        DAMAGE
        DRI3
        GLX
        ICCCM
        IMAGE
        KEYSYMS
        PRESENT
        RANDR
        RENDER
        SHAPE
        SHM
        SYNC
        XCB
        XFIXES
        XKB
        XINERAMA
        XINPUT
    )
    set_package_properties(XCB PROPERTIES TYPE REQUIRED)

    find_package(X11_XCB)
    set_package_properties(X11_XCB PROPERTIES
        PURPOSE "Required for building X11 windowed backend of kwin_wayland"
        TYPE OPTIONAL
    )

    find_package(Xwayland 23.1.0)
    set_package_properties(Xwayland PROPERTIES
        URL "https://x.org"
        DESCRIPTION "Xwayland X server"
        TYPE RUNTIME
        PURPOSE "Needed for running kwin_wayland"
    )
    set(HAVE_XWAYLAND_ENABLE_EI_PORTAL ${Xwayland_HAVE_ENABLE_EI_PORTAL})

    set(HAVE_GLX ${epoxy_HAS_GLX})
    get_target_property(QT_DISABLED_FEATURES Qt6::Gui QT_DISABLED_PUBLIC_FEATURES)
    if("xcb_glx_plugin" IN_LIST QT_DISABLED_FEATURES)
        message(STATUS "Disable GLX because Qt6::Gui was built without xcb_glx_plugin")
        set(HAVE_GLX false)
    endif()

    # for kwin internal things
    set(HAVE_X11_XCB ${X11_XCB_FOUND})

    find_package(X11)
    set_package_properties(X11 PROPERTIES
        DESCRIPTION "X11 libraries"
        URL "https://www.x.org"
        TYPE REQUIRED
    )

    # Scripts to run on XWayland startup
    set(XWAYLAND_SESSION_SCRIPTS "/etc/xdg/Xwayland-session.d")

else()
    set(KWIN_BUILD_X11_BACKEND OFF CACHE BOOL "Enable building kwin_x11" FORCE)
endif()

find_package(UDev)
set_package_properties(UDev PROPERTIES
    URL "https://www.freedesktop.org/wiki/Software/systemd/"
    DESCRIPTION "Linux device library."
    TYPE REQUIRED
    PURPOSE "Required for input handling on Wayland."
)

find_package(Libdrm 2.4.116)
set_package_properties(Libdrm PROPERTIES TYPE REQUIRED PURPOSE "Required for drm output on Wayland.")

find_package(gbm)
set_package_properties(gbm PROPERTIES TYPE REQUIRED PURPOSE "Required for egl output of drm backend.")
if (gbm_VERSION VERSION_GREATER_EQUAL 21.1)
    set(HAVE_GBM_BO_GET_FD_FOR_PLANE 1)
else()
    set(HAVE_GBM_BO_GET_FD_FOR_PLANE 0)
endif()
if (gbm_VERSION VERSION_GREATER_EQUAL 21.3)
    set(HAVE_GBM_BO_CREATE_WITH_MODIFIERS2 1)
else()
    set(HAVE_GBM_BO_CREATE_WITH_MODIFIERS2 0)
endif()

add_feature_info("XInput" X11_Xi_FOUND "Required for poll-free mouse cursor updates")
set(HAVE_X11_XINPUT ${X11_Xinput_FOUND})

find_package(lcms2)
set_package_properties(lcms2 PROPERTIES
    DESCRIPTION "Small-footprint color management engine"
    URL "http://www.littlecms.com"
    TYPE REQUIRED
    PURPOSE "Required for the color management system"
)

find_package(Freetype)
set_package_properties(Freetype PROPERTIES
    DESCRIPTION "A font rendering engine"
    URL "https://www.freetype.org"
    TYPE REQUIRED
    PURPOSE "Needed for KWin's QPA plugin."
)
find_package(Fontconfig)
set_package_properties(Fontconfig PROPERTIES
    TYPE REQUIRED
    PURPOSE "Needed for KWin's QPA plugin."
)

find_package(hwdata)
set_package_properties(hwdata PROPERTIES
    TYPE RUNTIME
    PURPOSE "Runtime-only dependency needed for mapping monitor hardware vendor IDs to full names"
    URL "https://github.com/vcrhonek/hwdata"
)

find_package(QAccessibilityClient6 CONFIG)
set_package_properties(QAccessibilityClient6 PROPERTIES
    URL "https://commits.kde.org/libqaccessibilityclient"
    DESCRIPTION "KDE client-side accessibility library"
    TYPE OPTIONAL
    PURPOSE "Required to enable accessibility features"
)
set(HAVE_ACCESSIBILITY ${QAccessibilityClient6_FOUND})

pkg_check_modules(libsystemd IMPORTED_TARGET libsystemd)
add_feature_info(libsystemd libsystemd_FOUND "Required for setting up the service watchdog")

if(KWIN_BUILD_GLOBALSHORTCUTS)
    find_package(KGlobalAccelD REQUIRED)
endif()

pkg_check_modules(libdisplayinfo REQUIRED IMPORTED_TARGET libdisplay-info>=0.2.0)
add_feature_info(libdisplayinfo libdisplayinfo_FOUND "EDID and DisplayID library: https://gitlab.freedesktop.org/emersion/libdisplay-info")

if (KWIN_BUILD_NOTIFICATIONS)
    find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS Notifications)
endif()

if (KWIN_BUILD_SCREENLOCKER)
    find_package(KScreenLocker CONFIG)
    set_package_properties(KScreenLocker PROPERTIES
        TYPE REQUIRED
        PURPOSE "For screenlocker integration in kwin_wayland"
    )
endif()

ecm_find_qmlmodule(QtQuick 2.3)
ecm_find_qmlmodule(QtQuick.Controls 2.15)
ecm_find_qmlmodule(QtQuick.Layouts 1.3)

=== doc/windowbehaviour-x11/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kcontrol/windowbehaviour-x11)

=== src/platformsupport/CMakeLists.txt ===
add_subdirectory(scenes)

=== src/backends/virtual/CMakeLists.txt ===
target_sources(kwin PRIVATE
    virtual_backend.cpp
    virtual_egl_backend.cpp
    virtual_logging.cpp
    virtual_output.cpp
    virtual_qpainter_backend.cpp
)

=== src/kcms/common/CMakeLists.txt ===
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcmkwincommon_x11\")

set(kcmkwincommon_SRC
    effectsmodel.cpp
)

qt_add_dbus_interface(kcmkwincommon_SRC
    ${KWin_SOURCE_DIR}/src/org.kde.kwin.Effects.xml kwin_effects_interface
)

add_library(kcmkwincommon SHARED ${kcmkwincommon_SRC})

target_link_libraries(kcmkwincommon
    Qt::Core
    Qt::DBus
    Qt::Quick
    KF6::CoreAddons
    KF6::ConfigCore
    KF6::I18n
    KF6::Package
    KF6::KCMUtils
)

set_target_properties(kcmkwincommon PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION 6
    OUTPUT_NAME "kcmkwincommon-x11"
)

install(TARGETS kcmkwincommon ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

set(kcm_kwin4_genericscripted_SRCS genericscriptedconfig.cpp)
qt_add_dbus_interface(kcm_kwin4_genericscripted_SRCS ${kwin_effects_dbus_xml} kwineffects_interface)
add_library(kcm_kwin4_genericscripted MODULE ${kcm_kwin4_genericscripted_SRCS})
target_link_libraries(kcm_kwin4_genericscripted
    KF6::KCMUtils #KCModule
    KF6::I18n
    Qt::DBus
    Qt::UiTools
)
install(TARGETS kcm_kwin4_genericscripted DESTINATION ${KDE_INSTALL_PLUGINDIR}/${KWIN_PLUGINDIR}/effects/configs)

=== src/plugins/maximize/CMakeLists.txt ===
kwin_add_scripted_effect(maximize package)

=== src/plugins/scale/CMakeLists.txt ===
kwin_add_scripted_effect(scale package)

=== src/plugins/showpaint/CMakeLists.txt ===
#######################################
# Effect

set(showpaint_SOURCES
    main.cpp
    showpaint.cpp
)

kwin_add_builtin_effect(showpaint ${showpaint_SOURCES})
target_link_libraries(showpaint PRIVATE
    kwin
)

=== src/plugins/windowview/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Vlad Zahorodnii <vlad.zahorodnii@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

if (KWIN_BUILD_KCMS)
    add_subdirectory(kcm)
endif()

set(windowview_SOURCES
    main.cpp
    windowvieweffect.cpp
)

kconfig_add_kcfg_files(windowview_SOURCES
    windowviewconfig.kcfgc
)

qt_add_dbus_adaptor(windowview_SOURCES org.kde.KWin.Effect.WindowView1.xml windowvieweffect.h KWin::WindowViewEffect)

kwin_add_builtin_effect(windowview ${windowview_SOURCES})

target_link_libraries(windowview PRIVATE
    kwin

    KF6::ConfigGui
    KF6::GlobalAccel
    KF6::I18n

    Qt::Quick
    )

install(DIRECTORY qml DESTINATION ${KDE_INSTALL_DATADIR}/${KWIN_DATADIR}/effects/windowview)

=== debian/changelog ===
kwin-x11 (4:6.5.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (6.5.0).
  * Update build-deps and deps with the info from cmake.
  * Refresh copyright information.
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 16 Oct 2025 22:04:24 +0200

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-kf6,
-               breeze-dev (>= 4:6.4.91~),
+               breeze-dev (>= 4:6.5.0~),
                cmake (>= 3.16~),
                extra-cmake-modules (>= 6.18.0~),
                gettext,
-               knighttime-dev (>= 6.4.91~),
+               knighttime-dev (>= 6.5.0~),
                kscreenlocker-dev (>= 6.4.91~),
-               kwayland-dev (>= 4:6.4.91~),
+               kwayland-dev (>= 4:6.5.0~),
                libcanberra-dev,
                libcap-dev [linux-any],
                libcap2-bin [linux-any],
@@ -23,7 +23,7 @@
                libfontconfig-dev,
                libfreetype-dev,
                libgbm-dev,
-               libkdecorations3-dev (>= 4:6.4.91~),
+               libkdecorations3-dev (>= 4:6.5.0~),
                libkf6auth-dev (>= 6.18.0~),
                libkf6colorscheme-dev (>= 6.18.0~),
                libkf6config-dev (>= 6.18.0~),
@@ -50,8 +50,8 @@
                libkglobalacceld-dev (>= 6.4.91~),
                libkirigami-dev (>= 6.18.0~),
                liblcms2-dev,
-               libplasma-dev (>= 6.4.91~),
-               libplasmaactivities-dev (>= 6.4.91~),
+               libplasma-dev (>= 6.5.0~),
+               libplasmaactivities-dev (>= 6.5.0~),
                libqaccessibilityclient-qt6-dev,
                libsystemd-dev [linux-any],
                libudev-dev [linux-any],
@@ -114,8 +114,8 @@
          xserver-xorg,
          ${misc:Depends},
          ${shlibs:Depends},
-Recommends: kwin-style-aurorae,
-            kde-style-breeze,
+Recommends: kde-style-breeze,
+            kwin-style-aurorae,
 Provides: kwin,
           x-window-manager,
 Breaks: kwin-common (<< 4:6.4.0~),

## kwin-x11 6.5.0+p24.04+vstable+git20251028.1305

=== debian/changelog ===
kwin-x11 (4:6.5.0+p24.04+vstable+git20251028.1305-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 28 Oct 2025 13:05:20 +0000

kwin-x11 (4:6.5.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 06:45:40 +0000

=== debian/control ===
Source: kwin-x11
Section: kde
Priority: optional
Uploaders: Maximiliano Curia <maxy@debian.org>
Build-Depends: breeze-dev,
               cmake,
               debhelper-compat (= 13),
               g++-14,
               gcc-14,
               hwdata,
               kf6-extra-cmake-modules,
               kf6-kauth-dev,
               kf6-kcmutils-dev,
               kf6-kcolorscheme-dev,
               kf6-kcompletion-dev,
               kf6-kconfig-dev,
               kf6-kconfigwidgets-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-kdeclarative-dev,
               kf6-kdoctools-dev,
               kf6-kglobalaccel-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-kidletime-dev,
               kf6-kio-dev,
               kf6-kirigami-dev,
               kf6-knewstuff-dev,
               kf6-knotifications-dev,
               kf6-kpackage-dev,
               kf6-krunner-dev,
               kf6-kservice-dev,
               kf6-ksvg-dev,
               kf6-ktextwidgets-dev,
               kf6-kwidgetsaddons-dev,
               kf6-kwindowsystem-dev,
               kf6-kxmlgui-dev,
               kglobalacceld-dev,
               knighttime-dev,
               kscreenlocker-dev,
               kwayland-dev,
               libaurorae-dev,
               libcanberra-dev,
               libcap-dev [linux-any],
               libdisplay-info-dev,
               libdrm-dev,
               libegl1-mesa-dev,
               libei-dev,
               libeis-dev,
               libepoxy-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libgbm-dev,
               libice-dev,
               libinput-dev,
               libkdecorations3-dev,
               liblcms2-dev,
               libpipewire-0.3-dev,
               libplasma-dev,
               libqaccessibilityclient-qt6-dev,
               libsm-dev,
               libsystemd-dev,
               libudev-dev [linux-any],
               libwayland-dev (>= 1.22),
               libx11-xcb-dev,
               libxcb-composite0-dev,
               libxcb-cursor-dev,
               libxcb-damage0-dev,
               libxcb-dri3-dev,
               libxcb-glx0-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-present-dev,
               libxcb-randr0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-util-dev,
               libxcb-xfixes0-dev,
               libxcb-xinerama0-dev,
               libxcb-xtest0-dev,
               libxcb1-dev,
               libxcursor-dev,
               libxcvt-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               pkg-kde-tools-neon,
               pkgconf,
               plasma-activities-dev,
               plasma-wayland-protocols,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-sensors-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-wayland-dev,
               wayland-protocols,
               xwayland
Standards-Version: 4.6.2
Homepage: https://projects.kde.org/projects/kde/workspace/kwin
Vcs-Git: https://invent.kde.org/neon/neon-packaging/kwin-x11.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/kwin-x11
Maintainer: Neon CI <neon@kde.org>

Package: kwin-x11-common
Architecture: any
Depends: aurorae,
         hwdata,
         kf6-kdeclarative,
         kf6-kglobalaccel,
         kf6-kirigami,
         libplasma6,
         qml6-module-org-kde-kitemmodels,
         qml6-module-org-kde-kquickcontrolsaddons,
         qml6-module-org-kde-quickcharts,
         qml6-module-qtmultimedia,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-virtualkeyboard,
         qml6-module-qtquick-window,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libmaliit-plugins2,
            maliit-keyboard,
            plasma-desktop,
            python3,
            qt6-virtualkeyboard
Breaks: kwin-addons (<< 4:6), kwin-common (<< 4:6.3.80)
Replaces: kwin-addons (<< 4:6), kwin-common (<< 4:6.3.80)
Description: KDE window manager, X11 version - common files
 KWin/X11 is an X11 window manager and a compositing manager. Its primary
 usage is in conjunction with a Desktop Shell (e.g. KDE Plasma Desktop).
 .
 KWin/X11 is designed to go out of the way; users should not notice that
 they use a window manager at all. Nevertheless KWin/X11 provides a steep
 learning curve for advanced features, which are available, if they do not
 conflict with the primary mission. KWin does not have a dedicated targeted
 user group, but follows the targeted user group of the Desktop Shell using
 KWin/X11 as it's window manager.

Package: kwin-x11-dev
Section: libdevel
Architecture: any
X-Neon-MergedPackage: true
Depends: kf6-kconfig-dev,
         kf6-kcoreaddons-dev,
         kf6-kwindowsystem-dev,
         kwin-x11-common (= ${binary:Version}),
         libegl1-mesa-dev (>= 1.2~),
         libepoxy-dev (>= 1.2),
         libwayland-dev,
         qt6-base-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: KDE window manager, X11 version - devel files
 KWin/X11 is an X11 window manager and a compositing manager. Its primary
 usage is in conjunction with a Desktop Shell (e.g. KDE Plasma Desktop).
 .
 KWin/X11 is designed to go out of the way; users should not notice that
 they use a window manager at all. Nevertheless KWin/X11 provides a steep
 learning curve for advanced features, which are available, if they do not
 conflict with the primary mission. KWin does not have a dedicated targeted
 user group, but follows the targeted user group of the Desktop Shell using
 KWin/X11 as it's window manager.

Package: kwin-x11
Architecture: any
X-Neon-MergedPackage: true
Depends: kwin-x11-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: kwin-x11, x-window-manager
Description: KDE window manager, X11 version
 KWin/X11 is an X11 window manager and a compositing manager. Its primary
 usage is in conjunction with a Desktop Shell (e.g. KDE Plasma Desktop).
 .
 KWin/X11 is designed to go out of the way; users should not notice that
 they use a window manager at all. Nevertheless KWin/X11 provides a steep
 learning curve for advanced features, which are available, if they do not
 conflict with the primary mission. KWin does not have a dedicated targeted
 user group, but follows the targeted user group of the Desktop Shell using
 KWin/X11 as it's window manager.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

# need gcc 14
export CC=gcc-14
export CXX=g++-14

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_CXX_STANDARD=23

## kwin-x11 6.5.0+p24.04+vunstable+git20251021.0820

=== debian/changelog ===
kwin-x11 (4:6.5.0+p24.04+vunstable+git20251021.0820-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 08:20:28 +0000
